#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include "LIST-LIB.h"


// funzione distruttore
lista::~lista()
{
   nodo *p;
   while(l!=0)
   {
      p=l;
      l=l->succ;
      delete p;
      cout << '#';
   }
   cout << endl;
}


// ----------- Funzioni di inserimento elemento in lista --------------------------

// N.B. devono essere usate in modo mutuamente esclusivo (si provveda a commentare
// quella che non interessa;

/* inserisce gli elementi in modo disordinato (inserimento in testa)     */
 
void lista::push(int x)
{
  nodo *appo;
  appo=new nodo;        // Alloca una elemento; il suo indirizzo e' appo
  appo->valore=x;
  appo->succ=l;
  l=appo;
}
     
/* inserisce gli elementi in modo ordinato (Versione ricorsiva)   */
/*
void lista::push(int x)
{
    l=insert(l,x);
}

nodo* lista::insert(nodo *p,int x)
{
  nodo *q;
  if( (p==0)||(x<=p->valore) )
  {                                       // base della ricorsione
	  q=new(nodo);        // Alloca una elemento; il suo ind. e' q
	  q->valore=x;
	  q->succ=p;
	  p=q;
  }
  else
	  p->succ=insert(p->succ, x);     // passo ricorsivo
  return p;    
}    */
    
// --------------------------------------------------------------------------------

/* cancella un elemento dalla lista - restituisce true se l'elemento e' stato trovato */ 
/* N.B. si ipotizza che la lista sia ORDINATA                                         */
bool lista::cancella(int x)     // versione iterativa
{
  nodo *lc, *lp;

  lc=l;
  lp=0;

  while( (lc!=0) && (lc->valore < x) )
  {
	lp=lc;
	lc=lc->succ;
  }
  if ( (lc!=0) && (lc->valore == x) )
  {
     if (lp==0)
	    l=l->succ;
	 else
	     lp->succ=lc->succ;
	 delete lc;
	 return true;
  }
  else
	 return false;
}


/* stampa a video gli elementi di una lista */
void lista::stampa()
{
  nodo *appo;
  
  appo=l;
  while(appo!=0)
  {
	 printf("elemento= %d\n",appo->valore);
     appo=appo->succ;
  }
}


/* verifica se un elemento e' presenta nella lista - restituisce true in caso affermativo */
/* N.B. non si fanno ipotesi sull'ordinamento della lista                                 */
bool lista::trova(int x)
{
   return find(l,x);
}

bool lista::find(nodo *lc, int elem)    /* RICORSIVA */
{
  if(lc==0)
	 return false;
  else if(lc->valore == elem)
	return true;
  else
	return find(lc->succ, elem);
}


/*  --------- ordinamento della lista con il metodo MERGE-SORT ------------- */

void lista::ordina()
{
   l=MergeSort(l);
}

nodo* lista::split(nodo *l1)
{
  nodo * l2;
  if( (l1==0)||(l1->succ==0) )
    return NULL;
  l2=l1->succ;
  l1->succ=l2->succ;
  l2->succ=split(l1->succ);
  return l2;
}

nodo* lista::Merge(nodo *l1, nodo *l2)
{
  if(l1==NULL)
    return l2;
  if(l2==NULL)
    return l1;
  if(l1->valore <= l2->valore)
  {
     l1->succ=Merge(l1->succ, l2);
     return l1;
  }
  else
  {
     l2->succ=Merge(l1, l2->succ);
     return l2;
  }
}

nodo* lista::MergeSort(nodo *l1)
{
  nodo *l2;
  if( (l1==0)||(l1->succ==0) )
     return l1;
  else
  {
    l2=split(l1);
    l1=MergeSort(l1);
    l2=MergeSort(l2);
    return Merge(l1,l2);
  }
}
// --------------------------------------------------------------------------------


void lista::fondi(lista &list1)
{
   l=Merge(l,list1.l);
   list1.l=0;
}


elem_tab* lista::calcola_freq()
{
  elem_tab *t, *tc, *ta;
  nodo *p;
  bool trovato;
  
  p=l;
  t=0;
  tc=0;
  
  while(p!=0)       // scorro la lista selezionando un elemento alla volta
  {
     trovato = false;
     ta=t;
     while( (ta!=0)&&(!trovato) )    //  cerco l'elemento in tabella
     {
        if(p->valore==ta->valore)
           trovato=true;
        else
           ta=ta->next;
     } 
     if (trovato)       // se lo trovo incremento la sua occorrenza
        (ta->occ)++;
     else               // altrimenti lo inserisco in coda alla tabella
     {   
        ta=new elem_tab;
        ta->valore=p->valore;
        ta->occ=1;
        ta->next=0;
        if(t==0)           // caso tabella vuota
           t=ta;
        else               // caso tabella con almeno un elemento
           tc->next=ta;
        tc=ta;
     }
     p=p->succ;
  }
  return t;

}


void print_tab(elem_tab *tab)
{
   printf("\nelemento \t occorrenza\n");
   while(tab!=0)
   {
      printf("%d\t \t %d\n",tab->valore,tab->occ);
      tab=tab->next;
   }
}       

       

